typo in backupninja.1
[matthijs/upstream/backupninja.git] / handlers / rdiff
index 82160f4fb5b03b86a36cdf45a4944611672dc383..46cae4981d0277e980d2b6671e32481e2aba4d67 100644 (file)
@@ -17,8 +17,8 @@ function test_connection() {
        fi
        local user=$1
        local host=$2
-       debug "ssh -o PasswordAuthentication=no $host -l $user 'echo -n 1'"
-       local ret=`ssh -o PasswordAuthentication=no $host -l $user 'echo -n host is alive'`
+       debug "ssh $sshoptions -o PasswordAuthentication=no $host -l $user 'echo -n 1'"
+       local ret=`ssh $sshoptions -o PasswordAuthentication=no $host -l $user 'echo -n host is alive'`
        if echo $ret | grep "host is alive"; then
                debug "Connected to $host as $user successfully"
        else
@@ -32,12 +32,12 @@ function get_version() {
        # if user or host is missing, returns the local version.
        if [ "$#" -lt 2 ]; then
                debug "$RDIFFBACKUP -V"
-               echo `$RDIFFBACKUP -V`
+                echo `$RDIFFBACKUP -V | cut -d. -f1,2`
        else
                local user=$1
                local host=$2
-               debug "ssh $host -l $user '$RDIFFBACKUP -V'"
-               echo `ssh $host -l $user "$RDIFFBACKUP -V | grep rdiff-backup"`
+               debug "ssh $sshoptions $host -l $user '$RDIFFBACKUP -V'"
+                echo `ssh $sshoptions $host -l $user "$RDIFFBACKUP -V | grep rdiff-backup | cut -d. -f1,2"`
        fi
 }
 
@@ -64,11 +64,19 @@ function check_consistency() {
        fi
 }
 
+function check_cstream() {
+       local cstream=$1
+       if [ ! -x $cstream ]; then
+               fatal "Can't find your cstream binary (trying: $cstream). If you use bwlimit you must have cstream installed."
+       fi
+}
+
 ### GET CONFIG ###
 
 getconf options
 getconf testconnect yes
 getconf nicelevel 0
+getconf bwlimit
 
 setsection source
 getconf type; sourcetype=$type
@@ -78,6 +86,7 @@ check_consistency "source" "$type" "$user" "$host"
 getconf label
 getconf keep 60
 getconf include
+getconf vsnames all
 getconf vsinclude
 getconf exclude
 
@@ -88,18 +97,31 @@ destdir=${destdir%/}
 getconf type; desttype=$type
 getconf user; destuser=$user
 getconf host; desthost=$host
+getconf sshoptions
 check_consistency "destination" "$type" "$user" "$host"
 
 ### CHECK CONFIG ###
 
-# See if vservers are configured
+# If vservers are configured, check that the ones listed in $vsnames do exist.
 local usevserver=no
-if [ $vservers_are_available = yes -a -n "$vsinclude" ]; then
-   info "vserver method enabled"
-   usevserver=yes
+if [ $vservers_are_available = yes ]; then
+   if [ "$vsnames" = all ]; then
+      vsnames="$found_vservers"
+   else
+      if ! vservers_exist "$vsnames" ; then
+            fatal "At least one of the vservers listed in vsnames ($vsnames) does not exist."
+      fi
+   fi
+   if [ -n "$vsinclude" ]; then
+      info "Using vservers '$vsnames'"
+      usevserver=yes
+   fi
+else
+   [ -z "$vsinclude" ] || warning 'vservers support disabled in backupninja.conf, vsincludes configuration lines will be ignored'
 fi
 
 # check the connection at the source and destination
+[ -n "$test" ] || test=0
 if [ "$testconnect" = "yes" ] || [ "${test}" -eq 1 ]; then
        test_connection $sourceuser $sourcehost
        test_connection $destuser $desthost
@@ -130,26 +152,43 @@ esac
        
 ### REMOVE OLD BACKUPS ###
 
-if [ "`echo $keep | tr -d 0-9`" == "" ]; then
+if [ "$keep" != yes ]; then
+
+   if [ "`echo $keep | tr -d 0-9`" == "" ]; then
        # add D if no other date unit is specified
-       keep="${keep}D"
-fi
+      keep="${keep}D"
+   fi
+
+   removestr="$RDIFFBACKUP $options --force --remove-older-than $keep "
+   if [ "$desttype" == "remote" ]; then
+      removestr="${removestr}${destuser}@${desthost}::"
+   fi
+   removestr="${removestr}${destdir}/${label}";
+
+   debug "$removestr"
+   if [ $test = 0 ]; then
+      output="`su -c "$removestr" 2>&1`"
+      if [ $? = 0 ]; then
+        debug $output
+        info "Removing backups older than $keep days succeeded."
+      else
+        warning $output
+        warning "Failed removing backups older than $keep."
+      fi
+   fi
 
-removestr="$RDIFFBACKUP --force --remove-older-than $keep "
-if [ "$desttype" == "remote" ]; then
-       removestr="${removestr}${destuser}@${desthost}::"
 fi
-removestr="${removestr}${destdir}/${label}";
 
-debug "$removestr"
-if [ ! $test ]; then
-       output=`$removestr 2>&1`
-       if [ $? = 0 ]; then
-               debug $output
-               info "Removing backups older than $keep days succeeded."
+# Add cstream 
+
+if [ ! -z $bwlimit ]; then
+       check_cstream $CSTREAM;
+       if [ "$desttype" = "remote" ]; then
+               RDIFFBACKUP="$RDIFFBACKUP --remote-schema 'cstream -t $bwlimit | ssh %s \''rdiff-backup --server\'''"
+       elif [ "$sourcetype" = "remote" ]; then
+               RDIFFBACKUP="$RDIFFBACKUP --remote-schema 'ssh %s \''rdiff-backup --server\'' | cstream -t $bwlimit'"
        else
-               warning $output
-               warning "Failed removing backups older than $keep."
+               fatal "You specified a bandwidth limit but neither your source nor destination types are remote."
        fi
 fi
 
@@ -157,29 +196,40 @@ fi
 
 execstr="$RDIFFBACKUP $options --print-statistics "
 
+set -o noglob
+
+symlinks_warning="Maybe you have mixed symlinks and '*' in this statement, which is not supported."
+
 # TODO: order the includes and excludes
 # excludes
-for i in "$exclude"; do
-       str="${i//__star__/*}"
-       execstr="${execstr}--exclude '$str' "
+for i in $exclude; do
+   str="${i//__star__/*}"
+   execstr="${execstr}--exclude '$str' "
 done
 # includes 
-for i in "$include"; do
-       [ "$i" != "/" ] || fatal "Sorry, you cannot use 'include = /'"
-       str="${i//__star__/*}"
-       execstr="${execstr}--include '$str' "
+for i in $include; do
+   [ "$i" != "/" ] || fatal "Sorry, you cannot use 'include = /'"
+   str="${i//__star__/*}"
+   execstr="${execstr}--include '$str' "
 done
 
 # vsinclude
 if [ $usevserver = yes ]; then
-       for vserver in `ls $VROOTDIR|grep -v lost+found`; do
-               for vi in "$vsinclude"; do
-                       str="${vi//__star__/*}"
-                       execstr="${execstr}--include '$VROOTDIR/$vserver$str' "
-               done
-       done
+   for vserver in $vsnames; do
+      for vi in $vsinclude; do
+        str="${vi//__star__/*}"
+        str="$VROOTDIR/$vserver$str"
+         if [ -n "$str" ]; then
+           execstr="${execstr}--include '$str' "
+         else
+            warning "vsinclude statement '${vi//__star__/*}' will be ignored for VServer $vserver. $symlinks_warning"
+         fi
+      done
+   done
 fi
 
+set +o noglob
+
 # exclude everything else
 execstr="${execstr}--exclude '/*' "
                
@@ -187,7 +237,7 @@ execstr="${execstr}--exclude '/*' "
 execstr="${execstr}$execstr_sourcepart $execstr_destpart"
 
 debug "$execstr"
-if [ ! $test ]; then
+if [ $test = 0 ]; then
        output=`nice -n $nicelevel su -c "$execstr" 2>&1`
        if [ $? = 0 ]; then
                debug $output